$ verify = 'F$VERIFY(0)'
$!.. BATQUEDEL.COM		Delete a waiting batch job by name
$ IF p1 .EQS "" THEN $ EXIT	F$VERIFY(verify).OR.1
$ ON ERROR THEN $ EXIT	F$VERIFY(verify).OR.1
$ IF p2 .EQS. "" THEN p2 = "SYS$BATCH"
$ IF F$LOGICAL( p2) .NES. "" THEN p2 = F$LOGICAL( p2)	!Logical "queue" name
$ IF p3 .EQS. "" THEN p3 = F$EDIT( F$GETJPI("", "USERNAME"), "COLLAPSE")
$ SHOW QUEUE /BATCH /ALL /OUTPUT=BATCHQ.TMP  'p2'	!Show all jobs in queue
$ JOB_TIME == ""			! Init for null return
$ OPEN/READ  BATCHQ:  BATCHQ.TMP
$ line_number = 0
$READ_LOOP:				! Read output of SHOW QUEUE command
$  READ/END_OF_FILE=END_LOOP  BATCHQ:  record
$  line_number = line_number + 1	!Lines 1-4 are heading and ignored
$  IF line_number .LT. 5 THEN $ GOTO READ_LOOP
$  record = F$EDIT( record, "COMPRESS,TRIM")
$  IF F$ELEMENT( 1, " ", record) .NES. " " THEN $ GOTO NOT_CONTINUED
$    READ/END_OF_FILE=END_LOOP  BATCHQ:  continuation	!Read continuation line
$    record = record + " " + F$EDIT( continuation, "COMPRESS,TRIM")
$NOT_CONTINUED:				!Will have concatenated continuations.
$  state_of_job = F$ELEMENT( 3," ", record)
$  IF (state_of_job .NES. "Pending") .AND. -
      (state_of_job .NES. "Holding") THEN $ GOTO READ_LOOP
$  job_name = F$ELEMENT( 0," ", record)	!Found pending/holding job
$  IF job_name .NES. p1 THEN $ GOTO READ_LOOP
$  job_number = F$ELEMENT( 2, " ", record)	!Got job, get entry number
$  IF p3 .EQS. "*" THEN $ GOTO SKIP_USERNAME_CHECK
$    IF F$ELEMENT( 1," ", record) .NES. p3 THEN $ GOTO READ_LOOP
$SKIP_USERNAME_CHECK:
$  this_time = ""		!Default to not being held "until"
$  IF F$ELEMENT( 4," ", record) .NES. "until" THEN $ GOTO DELETE_JOB
$    this_time = F$ELEMENT( 5," ", record) + "-" + F$ELEMENT( 6," ", record)
$    job_time == this_time
$DELETE_JOB:
$  DELETE/ENTRY='job_number'	'p2'
$  IF this_time .NES. "" THEN state_of_job = state_of_job + " until "
$  WRITE SYS$OUTPUT "Deleted job ", job_name, "/ENTRY=", job_number,-
		    " from ", p2," ", state_of_job, this_time
$  GOTO READ_LOOP
$END_LOOP:
$ CLOSE BATCHQ:
$ DELETE BATCHQ.TMP;*
$ WRITE SYS$OUTPUT " "
$END_PROC:
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$! BATQUEDEL.COM
$!
$!+ BATQUEDEL
$! Delete batch jobs by name (rather than by queue entry number):
$!
$!	@FERMI$UTIL:BATQUEDEL   jobname  [queue]  [username]
$!
$! The P1 parameter gives the job name of the batch jobs to be deleted
$! (all jobs with this name may be affected).  If no P1 parameter is
$! given, the procedure exits immediately.  The P2 parameter selects
$! the batch queue to be searched, if none is specified, SYS$BATCH is
$! used.  The P3 parameter specifies the username whose jobs are to
$! be deleted.  If no user is specified, then the current process's
$! username is used.  If P3 is "*", then the username is not used to
$! limit which batch jobs are deleted.
$!
$! Even if the job name and username (if checked for) match, currently
$! executing batch jobs are not deleted by this procedure, only those
$! batch jobs with a status of "Pending" or "Holding" are deleted.
$!
$! If a job is deleted which was waiting to execute at a specified time
$! ("Holding until" status), then the absolute time it was waiting for
$! is returned in the global symbol DCL JOB_TIME.  If no job with
$! "Holding until" status was found then JOB_TIME is returned as a null
$! string.  If more than one job is waiting, the JOB_TIME returned is for
$! the last job in the queue.
$!-
$! The assumed format of the SHOW QUEUE output includes the following
$! for the format of lines describing jobs, the first 4 lines are headings
$! and queue identification and are ignored:
$!
$!	Columns	Item#	Contents
$!	-------	-----	--------
$!	3-17	0	Job name
$!	19-30	1	Username of batch job
$!	32-37	2	Entry number in queue
$!	39-...	3,4	Status: "Executing", "Pending", "Holding" or
$!			"Holding until".
$!	53-69	5,6	Absolute date if "Holding until".
$!
$! The various fields are separated by spaces, so the line can have leading
$! and trailing spaces trimmed and multiple spaces compressed, then the
$! F$ELEMENT() lexical function can be used to access the various items
$! using a space as the delimiter.
$!=============================================================================
$! Author:	Frank J. Nagy	Fermilab Accelerator Controls
$! Modifications:
$!  13-May-81	FJN	Created, edit history lost until...
$!  21-Aug-82	FJN	For VMS V3 format of SHOW QUEUE output
$!  26-Aug-82	FJN	Comments added defining assumed format of the
$!			SHOW QUEUE output.
$!  03-Sep-82	FJN	Truncate trailing blanks
$!  06-Oct-82	FJN	Fix due to another difference in printout file
$!  29-Nov-83	FJN	Moved to FERMI$UTIL:
$!  26-Jul-84	FJN	Added queue (P2) parameter
$!  07-Jun-85	FJN	Modified for VMS V4 format of SHOW QUEUE output and
$!			to use VMS V4 lexical functions
$!  10-Jun-85	FJN	Fixed F$ELEMENT element #'s - start at 0 and debugged
$!			and provided for continuation lines when long job names
$!  24-Oct-85	FJN	Check for queue name is really a logical name (which is
$!			assumed to re-direct to a real queue name).
