/*
 V1.0	ages past	Created by Martin Minow, part of DECUS C system
 V2.0	01-Aug-84  FJN	Modified to explicitly trim trailing blanks and tabs,
			Frank J. Nagy, Fermilab Accelerator/Controls
 V3.0	01-Dec-85  FJN	Modified for VAX native mode using VAX C V2.0
 V3.1	07-Sep-86  FJN	Completed VAX C V2.0 modifications
*/

#ifdef vaxc
#include stdio
#else
#include <stdio.h>
#endif

#define	FALSE	0
#define	TRUE	1
#define	EOS	0
#define	BLANK	' '
#define	TAB	'\t'
#define	NEWLINE	'\n'
#define	FALSE	0
#define	TRUE	1

static char line[513];

main(argc, argv)
char *argv[];
{
register int	i;
register char	*lstart;
register char	*lend;

for (i = 1; i < argc; i++)
    {
    if (i == 1)
	{
	if (freopen(argv[i], "r", stdin) == NULL)
	    {
	    perror(argv[i]);
	    exit(1);
	    }
	}
	else
	{
#ifdef vaxc
	if (freopen(argv[i], "w", stdout, "rfm=var", "rat=cr") == NULL)
#else
	if (freopen(argv[i], "w", stdout) == NULL)
#endif
	    {
	    perror(argv[i]);
	    exit(1);
	    }
	}
    }

while (gets(line) != NULL)
    {
    /*
     * Get point to end of string and work backwards over
     * trailing spaces and tabs.
     */
    for (lend = line; *lend != EOS; lend++);

    if (lend != line)
	{
	lend--;
	while ((*lend == BLANK) || (*lend == TAB))
	    lend--;
	*(++lend) = EOS;
	}

    lstart = line;
    while ((lend = strchr(lstart, TAB)) != NULL)
	{
	/*
	 * Found a tab.
	 */
	*lend++ = EOS;
	printf("%s", lstart);
	i = 8 - ((lend - lstart - 1) & 07);
	while (--i >= 0)
	    putchar(BLANK);
	lstart = lend;
	}
    printf("%s\n", lstart);
    }
}		
