/*+ IODEF
 I/O function code definitions
 Extracted from V4.4 SYS$LIBRARY:STARLET.REQ on  10-Jun-1986 
 *** start Physical I/O function codes ***
*/
#define IO$_NOP		0	/* no operation */
#define IO$_UNLOAD	1	/* unload drive */
#define IO$_LOADMCODE	1	/* load microcode */
#define IO$_SEEK	2	/* seek cylinder */
#define IO$_SPACEFILE	2	/* space files */
#define IO$_STARTMPROC	2	/* start microprocessor */
#define IO$_RECAL	3	/* recalibrate drive */
#define IO$_STOP	3	/* stop */
#define IO$_DRVCLR	4	/* drive clear */
#define IO$_INITIALIZE	4	/* initialize */
#define IO$_RELEASE	5	/* release port */
#define IO$_SETCLOCKP	5	/* set clock (physical) */
#define IO$_OFFSET	6	/* offset read heads */
#define IO$_ERASETAPE	6	/* erase tape */
#define IO$_STARTDATAP	6	/* start data transfer (physical) */
#define IO$_RETCENTER	7	/* return to centerline */
#define IO$_QSTOP	7	/* queue stop request */
#define IO$_PACKACK	8	/* pack acknowledge */
#define IO$_SEARCH	9	/* search for sector */
#define IO$_SPACERECORD	9	/* space records */
#define IO$_READRCT	9	/* read replacement & caching table */
#define IO$_WRITECHECK	10	/* write check data */
#define IO$_WRITEPBLK	11	/* write physical block */
#define IO$_READPBLK	12	/* read physical block */
#define IO$_WRITEHEAD	13	/* write header and data */
#define IO$_RDSTATS	13	/* read statistics */
#define IO$_CRESHAD	13	/* create a shadow set */
#define IO$_READHEAD	14	/* read header and data */
#define IO$_ADDSHAD	14	/* add member to shadow set */
#define IO$_WRITETRACKD	15	/* write track data */
#define IO$_COPYSHAD	15	/* perform shadow set copy operations */
#define IO$_READTRACKD	16	/* read track data */
#define IO$_REMSHAD	16	/* remove member from shadow set */
#define IO$_AVAILABLE	17	/* available (disk and tape class) */
#define IO$_SETPRFPATH	18	/* set preferred path */
#define IO$_DSE		21	/* data security erase (and rewind) */
#define IO$_REREADN	22	/* reread next */
#define IO$_REREADP	23	/* reread previous */
#define IO$_WRITERET	24	/* write retry */
#define IO$_WRITECHECKH	24	/* write check header and data */
#define IO$_READPRESET	25	/* readin preset */
#define IO$_STARTSPNDL	25	/* start spindle */
#define IO$_SETCHAR	26	/* set characteristics */
#define IO$_SENSECHAR	27	/* sense tape characteristics */
#define IO$_WRITEMARK	28	/* write tape mark */
#define IO$_WRTTMKR	29	/* write tape mark retry */
#define IO$_DIAGNOSE	29	/* diagnose */
#define IO$_SHADMV	29	/* preform mount ver. on shadow set */
#define IO$_FORMAT	30	/* format */
#define IO$_CLEAN	30	/* clean tape */
#define IO$_PHYSICAL	31	/* highest physical i/o function code */
/*
 *** start Logical I/O function codes ***
*/
#define IO$_WRITELBLK	32	/* write logical block */
#define IO$_READLBLK	33	/* read logical block */
#define IO$_REWINDOFF	34	/* rewind and set offline */
#define IO$_SETMODE	35	/* set mode */
#define IO$_REWIND	36	/* rewind tape */
#define IO$_SKIPFILE	37	/* skip files */
#define IO$_SKIPRECORD	38	/* skip records */
#define IO$_SENSEMODE	39	/* sense tape mode */
#define IO$_WRITEOF	40	/* write end of file */
#define IO$_TTY_PORT	41	/* terminal port fdt routine */
#define IO$_LOGICAL	47	/* highest logical i/o function code */
/*
 *** start Virtual I/O function codes
*/
#define IO$_WRITEVBLK	48	/* write virtual block */
#define IO$_READVBLK	49	/* read virtual block */
#define IO$_ACCESS	50	/* access file */
#define IO$_CREATE	51	/* create file */
#define IO$_DEACCESS	52	/* deaccess file */
#define IO$_DELETE	53	/* delete file */
#define IO$_MODIFY	54	/* modify file */
#define IO$_NETCONTROL	54	/* x25 network control function */
#define IO$_READPROMPT	55	/* read terminal with prompt */
#define IO$_SETCLOCK	55	/* set clock */
#define IO$_ACPCONTROL	56	/* miscellaneous acp control */
#define IO$_STARTDATA	56	/* start data */
#define IO$_MOUNT	57	/* mount volume */
#define IO$_TTYREADALL	58	/* terminal read passall */
#define IO$_TTYREADPALL	59	/* term read w/prompt passall */
#define IO$_CONINTREAD	60	/* connect to interrupt readonly */
#define IO$_CONINTWRITE	61	/* connect to interrupt with write */
#define IO$_VIRTUAL	63	/* highest virtual i/o function */
/*
 Function modifier bit definitions
*/
#define IO$M_FCODE	0X3F
#define IO$M_FMODIFIERS	0XFFC0
#define IO$M_INHERLOG	0X800
#define IO$M_ERASE	0X400
#define IO$M_ENCRYPT	0X2000
#define IO$M_DATACHECK	0X4000
#define IO$M_INHRETRY	0X8000
#define IO$M_INHSEEK	0X1000
#define IO$M_REVERSE	0X40
#define IO$M_NOWAIT	0X80
#define IO$M_INHEXTGAP	0X1000
#define IO$M_MSCPMODIFS	0X100
#define IO$M_SHADOW	0X40
#define IO$M_LOCATE	0X80
#define IO$M_ALLHOSTS	0X40
#define IO$M_DISSOLVE	0X80
#define IO$M_NOCLEANUP	0X100
#define IO$M_SPINDOWN	0X40
#define IO$M_FORCEPATH	0X40
#define IO$M_COMMOD	0X40
#define IO$M_MOVETRACKD	0X80
#define IO$M_DIAGNOSTIC	0X100
#define IO$M_SKPSECINH	0X200
#define IO$M_DELDATA	0X40
#define IO$M_NOMRSP	0X40
#define IO$M_SWAP	0X100
#define IO$M_OPPOSITE	0X200
#define IO$M_CLSEREXCP	0X200
#define IO$M_ACCESS	0X40
#define IO$M_CREATE	0X80
#define IO$M_DELETE	0X100
#define IO$M_MOUNT	0X200
#define IO$M_DMOUNT	0X400
#define IO$M_REMOUNT	0X800
#define IO$M_BINARY	0X40
#define IO$M_PACKED	0X80
#define IO$M_NOW	0X40
#define IO$M_READATTN	0X80
#define IO$M_WRTATTN	0X100
#define IO$M_SETPROT	0X200
#define IO$M_NORSWAIT	0X400
#define IO$M_NOECHO	0X40
#define IO$M_TIMED	0X80
#define IO$M_CVTLOW	0X100
#define IO$M_NOFILTR	0X200
#define IO$M_DSABLMBX	0X400
#define IO$M_PURGE	0X800
#define IO$M_TRMNOECHO	0X1000
#define IO$M_REFRESH	0X2000
#define IO$M_ESCAPE	0X4000
#define IO$M_EXTEND	0X8000
#define IO$M_CANCTRLO	0X40
#define IO$M_ENABLMBX	0X80
#define IO$M_NOFORMAT	0X100
#define IO$M_BREAKTHRU	0X200
#define IO$M_NEWLINE	0X400
#define IO$M_TYPEAHDCNT	0X40
#define IO$M_MAINT	0X40
#define IO$M_CTRLYAST	0X80
#define IO$M_CTRLCAST	0X100
#define IO$M_HANGUP	0X200
#define IO$M_OUTBAND	0X400
#define IO$M_TT_CONNECT	0X800
#define IO$M_TT_DISCON	0X1000
#define IO$M_TT_PROCESS	0X2000
#define IO$M_BRDCST	0X4000
#define IO$M_LOOP	0X80
#define IO$M_UNLOOP	0X100
#define IO$M_LINE_OFF	0X200
#define IO$M_SET_MODEM	0X400
#define IO$M_LINE_ON	0X800
#define IO$M_LOOP_EXT	0X1000
#define IO$M_AUTXOF_ENA	0X2000
#define IO$M_AUTXOF_DIS	0X4000
#define IO$M_INCLUDE	0X800
#define IO$M_TT_ABORT	0X1000
#define IO$M_INTERRUPT	0X40
#define IO$M_ABORT	0X100
#define IO$M_SYNCH	0X200
#define IO$M_STARTUP	0X40
#define IO$M_SHUTDOWN	0X80
#define IO$M_ATTNAST	0X100
#define IO$M_CTRL	0X200
#define IO$M_RD_MEM	0X40
#define IO$M_RD_MODEM	0X80
#define IO$M_RD_COUNT	0X100
#define IO$M_CLR_COUNT	0X400

#define IO$K_SRRUNOUT	0	/* send or rcv until cnt runout */
#define IO$K_PTPBSC	8192	/* point to point bsc control */
#define IO$K_LOOPTEST	57344	/* loop test */
/*
 X25 driver WRITEBLK function modifier bits.
*/
#define IO$M_MORE	0X40
#define IO$M_QUALIFIED	0X80
#define IO$M_REDIRECT	0X40
#define IO$M_ACCEPT	0X80
#define IO$M_SETEVF	0X40
#define IO$M_WORD	0X40
#define IO$M_SETFNCT	0X200
#define IO$M_DATAPATH	0X400
#define IO$M_CYCLE	0X1000
#define IO$M_RESET	0X2000
#define IO$M_SETCUADR	0X100
#define IO$M_SETBSIZE	0X200
#define IO$M_SETPOOLSZ	0X400
#define IO$M_SETENQCNT	0X800
#define IO$M_CLEAR	0X1000
#define IO$M_LPBEXT	0X2000
#define IO$M_LPBINT	0X4000
#define IO$M_READCSR	0X8000
#define IO$M_NOCTSWAIT	0X40
#define IO$M_SLAVLOOP	0X80
#define IO$M_NODSRWAIT	0X100
#define IO$M_MAINTLOOP	0X200
#define IO$M_LASTBLOCK	0X400
#define IO$M_INTCLOCK	0X1000
#define IO$S_IODEF	2
/*
 Basic I/O function code/modifiers structure
*/
#define IO$V_FCODE	0
#define IO$S_FCODE	6	/* function code field */
#define IO$V_FMODIFIERS	6
#define IO$S_FMODIFIERS	10	/* function modifiers field */
/*
 Function modifiers common to all drivers which do error logging
*/
#define IO$V_INHERLOG	11	/* inhibit error logging */
/*
 General disk and tape function code modifiers
*/
#define IO$V_ERASE	10	/* erase data */
#define IO$V_ENCRYPT	13	/* encryption */
#define IO$V_DATACHECK	14	/* write check data after transfer */
#define IO$V_INHRETRY	15	/* inhibit error retry */
/*
 General disk function code modifiers
*/
#define IO$V_INHSEEK	12	/* inhibit implied seek on physical functions */
/*
 General tape function code modifiers
*/
#define IO$V_REVERSE	6	/* reverse operation */
#define IO$V_NOWAIT	7	/* no wait for rewind to complete */
#define IO$V_INHEXTGAP	12	/* inhibit extended inter-record gap */
/*
 DU  & TU, disk & tape class driver transfer function modifier bits
*/
#define IO$V_MSCPMODIFS	8	/* use mscp modifiers in p5 */
#define IO$V_SHADOW	6	/* shadowing sensechar */
#define IO$V_LOCATE	7	/* shadowing locate function */
#define IO$V_ALLHOSTS	6	/* do available as for all class drivers */
#define IO$V_DISSOLVE	7	/* dissolve shadow set */
#define IO$V_NOCLEANUP	8	/* normal shadow set cleanup not necessary */
#define IO$V_SPINDOWN	6	/* spin down removed member */
#define IO$V_FORCEPATH	6	/* make path change happen */
/*
 DR driver function modifier bits.
*/
#define IO$V_COMMOD	6	/* diagnostic command */
#define IO$V_MOVETRACKD	7	/* move track descriptor */
#define IO$V_DIAGNOSTIC	8	/* diagnostic function */
#define IO$V_SKPSECINH	9	/* skip sector inhibit */
/*
 DY driver function modifier bits.
*/
#define IO$V_DELDATA	6	/* write deleted data mark */
/*
 DD driver (TU58) function modifier bits.
*/
#define IO$V_NOMRSP	6	/* do not use mrsp for this operation */
/*
 Magnetic tape I/O function modifier bits for the TS11.
*/
#define IO$V_SWAP	8	/* swap byte (ts11) */
#define IO$V_OPPOSITE	9	/* opposite bit for rereads (ts11) */
/*
 TU driver function modifier bits
*/
#define IO$V_CLSEREXCP	9	/* clear serious exception condition */
/*
 ACP function modifier bits.
*/
#define IO$V_ACCESS	6	/* access file */
#define IO$V_CREATE	7	/* create file */
#define IO$V_DELETE	8	/* delete file */
#define IO$V_MOUNT	9	/* mount volume */
#define IO$V_DMOUNT	10	/* dismount volume */
#define IO$V_REMOUNT	11	/* remount volume */
/*
 CR (card reader) driver function modifier bits.
*/
#define IO$V_BINARY	6	/* binary read */
#define IO$V_PACKED	7	/* packed read */
/*
 MB (mailbox) driver function modifier bits.
*/
#define IO$V_NOW	6	/* do not wait for operation complete */
#define IO$V_READATTN	7	/* request ast on waiting reader */
#define IO$V_WRTATTN	8	/* request ast on waiting writer */
#define IO$V_SETPROT	9	/* set volume protection */
#define IO$V_NORSWAIT	10	/* do not allow resource waits */
/*
 TT driver READ function modifier bits.
*/
#define IO$V_NOECHO	6	/* noecho */
#define IO$V_TIMED	7	/* timed */
#define IO$V_CVTLOW	8	/* convert lower case */
#define IO$V_NOFILTR	9	/* no filter */
#define IO$V_DSABLMBX	10	/* disable mailbox */
#define IO$V_PURGE	11	/* purge typeahead */
#define IO$V_TRMNOECHO	12	/* terminators are not echoed */
#define IO$V_REFRESH	13	/* control-r interrupted read */
#define IO$V_ESCAPE	14	/* terminate read on escape sequence */
#define IO$V_EXTEND	15	/* used by alternate class drivers */
/*
 TT driver WRITE function modifier bits.
*/
#define IO$V_CANCTRLO	6	/* cancel control o */
#define IO$V_ENABLMBX	7	/* enable mailbox */
#define IO$V_NOFORMAT	8	/* do not format output */
#define IO$V_BREAKTHRU	9	/* broadcast i/o */
#define IO$V_NEWLINE	10	/* output a newline */
/*
 TT driver SENSEMODE function modifier bits.
*/
#define IO$V_TYPEAHDCNT	6	/* sense typeahead information */
/*
 TT driver SETMODE subfunction modifier bits.
*/
#define IO$V_MAINT	6	/* enable maint sub modifiers */
#define IO$V_CTRLYAST	7	/* set control y ast */
#define IO$V_CTRLCAST	8	/* set control c */
#define IO$V_HANGUP	9	/* set mode and hang up line */
#define IO$V_OUTBAND	10	/* set out of band ast */
#define IO$V_TT_CONNECT	11	/* connect to detached terminal */
#define IO$V_TT_DISCON	12	/* disconnect detached terminal */
#define IO$V_TT_PROCESS	13	/* define controlling process */
#define IO$V_BRDCST	14	/* define broadcast mask */
/*
 TT driver MAINTIANCE subfunction submodifier bits.
*/
#define IO$V_LOOP	7	/* diagnostic loopback */
#define IO$V_UNLOOP	8	/* diagnostic reset loopback */
#define IO$V_LINE_OFF	9	/* disable line */
#define IO$V_SET_MODEM	10	/* diagnostic modem control */
#define IO$V_LINE_ON	11	/* enable line */
#define IO$V_LOOP_EXT	12	/* diagnostic external loopback */
#define IO$V_AUTXOF_ENA	13	/* enable auto xoff */
#define IO$V_AUTXOF_DIS	14	/* disable auto xoff */
/*
 TT driver out-of-band modifier bits.
*/
#define IO$V_INCLUDE	11	/* include character in stream */
#define IO$V_TT_ABORT	12	/* abort current i/o */
/*
 Network WRITE VIRTUAL function modifier bits.
*/
#define IO$V_INTERRUPT	6	/* interrupt message */
/*
 Network ACCESS/DEACCESS function modifier bits.
*/
#define IO$V_ABORT	8	/* disconnect abort/connect reject */
#define IO$V_SYNCH	9	/* synchronous disconnect */
/*
 DATALINK driver SETMODE subfunction modifier bits.
*/
#define IO$V_STARTUP	6	/* start protocol */
#define IO$V_SHUTDOWN	7	/* stop protocol */
#define IO$V_ATTNAST	8	/* attention ast */
#define IO$V_CTRL	9	/* controller (ie. not station) function */
/*
 DATALINK driver SENSEMODE subfunction modifier bits.
*/
#define IO$V_RD_MEM	6	/* read device memory */
#define IO$V_RD_MODEM	7	/* read modem status */
#define IO$V_RD_COUNT	8	/* read counters */
#define IO$V_CLR_COUNT	10	/* clear counters */
#define IO$V_MORE	6	/* more data follows (m-bit) */
#define IO$V_QUALIFIED	7	/* use qualified sub-channel (q-bit) */
/*
 X25 driver ACCESS function modifier bits.
*/
#define IO$V_REDIRECT	6	/* redirect virtual call */
#define IO$V_ACCEPT	7	/* accept virtual call */
/*
 LPA-11 driver STARTDATA modifier bits.
*/
#define IO$V_SETEVF	6	/* set event flag */
/*
 XA (DR11-W) driver function modifier bits.
*/
#define IO$V_WORD	6	/* word (interrupt)/block (dma) mode specifier */
#define IO$V_SETFNCT	9	/* set "FNCT" bits in device csr */
#define IO$V_DATAPATH	10	/* change uba datapath (direct/buffered) */
#define IO$V_CYCLE	12	/* set "cycle" bit in device csr */
#define IO$V_RESET	13	/* device reset specifier */
/*
 3271 driver function modifier bits.
*/
#define IO$V_SETCUADR	8	/* set a new cu address */
#define IO$V_SETBSIZE	9	/* set a new maximum buffer size */
#define IO$V_SETPOOLSZ	10	/* set a new pool size */
#define IO$V_SETENQCNT	11	/* set a new enq threshold */
#define IO$V_CLEAR	12	/* zero status counters */
#define IO$V_LPBEXT	13	/* loopback is external loopback */
#define IO$V_LPBINT	14	/* loopback is internal loopback (dup11) */
#define IO$V_READCSR	15	/* read csrs on dup11 */
/*
 XW driver function modifier bits.
*/
#define IO$V_NOCTSWAIT	6	/* diagnostic function */
#define IO$V_SLAVLOOP	7	/* diagnostic function */
#define IO$V_NODSRWAIT	8	/* do not wait for dsr (diag) */
#define IO$V_MAINTLOOP	9	/* internal maint loop */
#define IO$V_LASTBLOCK	10	/* last block of message */
#define IO$V_INTCLOCK	12	/* internal clock */
 
