/* QUIDEF
 Get Queue Information Service Request codes ($GETQUI)
-*/
/* Extracted from V4.4 SYS$LIBRARY:STARLET.REQ on  10-Jun-1986 */
				/* Function codes */
#define QUI$_CANCEL_OPERATION	1	/* cancel a wildcard operation */
#define QUI$_DISPLAY_CHARACTERISTIC 2	/* return characteristic attributes */
#define QUI$_DISPLAY_FILE	3	/* return file attributes */
#define QUI$_DISPLAY_FORM	4	/* return form attributes */
#define QUI$_DISPLAY_JOB	5	/* return job attributes */
#define QUI$_DISPLAY_QUEUE	6	/* return queue attributes */
#define QUI$_TRANSLATE_QUEUE	7	/* validate and translate queue name */
#define QUI$_RESERVED_FUNC_1	8	/* reserved for digital use (name may change) */
#define QUI$_RESERVED_FUNC_2	9	/* reserved for digital use (name may change) */
				/* Item codes */
#define QUI$_ACCOUNT_NAME	1	/* job: submitter's account name */
#define QUI$_AFTER_TIME		2	/* job: /after=time */
#define QUI$_ASSIGNED_QUEUE_NAME 3	/* queue: assign/queue target */
#define QUI$_BASE_PRIORITY	4	/* queue: /base_priority=n */
#define QUI$_CHARACTERISTIC_NAME 5	/* characteristic: name */
#define QUI$_CHARACTERISTIC_NUMBER 6	/* characteristic: number */
#define QUI$_CHARACTERISTICS	7	/* job, queue: /characteristics=(c,...) */
#define QUI$_CHECKPOINT_DATA	8	/* job: checkpoint data */
#define QUI$_CLI		9	/* job: /cli=filename */
#define QUI$_COMPLETED_BLOCKS	10	/* job: completed blocks including checkpoint */
#define QUI$_CONDITION_VECTOR	11	/* job: completion status */
#define QUI$_CPU_DEFAULT	12	/* queue: /cpudefault=t */
#define QUI$_CPU_LIMIT		13	/* job, queue: /cpumaximum=t */
#define QUI$_DEVICE_NAME	14	/* queue: /on=device */
#define QUI$_ENTRY_NUMBER	15	/* job: entry number */
#define QUI$_FILE_COPIES	16	/* file: /copies=n */
#define QUI$_FILE_COPIES_CHKPT	17	/* file: file copies checkpoint */
#define QUI$_FILE_COPIES_DONE	18	/* file: file copies completed */
#define QUI$_FILE_FLAGS		19	/* file: boolean information */
#define QUI$_FILE_SETUP_MODULES	20	/* file: /setup=(module,...) */
#define QUI$_FILE_SPECIFICATION	21	/* file: full file specification */
#define QUI$_FILE_STATUS	22	/* file: status information */
#define QUI$_FIRST_PAGE		23	/* file: /pages=(n,"") */
#define QUI$_FORM_DESCRIPTION	24	/* form: /description=string */
#define QUI$_FORM_FLAGS		25	/* form: boolean information */
#define QUI$_FORM_LENGTH	26	/* form: /length=n */
#define QUI$_FORM_MARGIN_BOTTOM	27	/* form: /margin=bottom=n */
#define QUI$_FORM_MARGIN_LEFT	28	/* form: /margin=left=n */
#define QUI$_FORM_MARGIN_RIGHT	29	/* form: /margin=right=n */
#define QUI$_FORM_MARGIN_TOP	30	/* form: /margin=top=n */
#define QUI$_FORM_NAME		31	/* form, job, queue: form name */
#define QUI$_FORM_NUMBER	32	/* form: number */
#define QUI$_FORM_SETUP_MODULES	33	/* form: /setup=(module,...) */
#define QUI$_FORM_STOCK		34	/* form: /stock=stock-name */
#define QUI$_FORM_WIDTH		35	/* form: /width=n */
#define QUI$_GENERIC_TARGET	36	/* queue: /generic=(queue-name,...) */
#define QUI$_INTERVENING_BLOCKS	37	/* job: intervening pending blocks */
#define QUI$_INTERVENING_JOBS	38	/* job: intervening pending jobs */
#define QUI$_JOB_COPIES		39	/* job: /job_count=n */
#define QUI$_JOB_COPIES_CHKPT	40	/* job: job copies checkpoint */
#define QUI$_JOB_COPIES_DONE	41	/* job: job copies completed */
#define QUI$_JOB_FLAGS		42	/* job: boolean information */
#define QUI$_JOB_LIMIT		43	/* queue: /job_limit=n */
#define QUI$_JOB_NAME		44	/* job: name */
#define QUI$_JOB_RESET_MODULES	45	/* queue: /separate=reset=(module,...) */
#define QUI$_JOB_SIZE		46	/* job: total blocks in job */
#define QUI$_JOB_SIZE_MAXIMUM	47	/* queue: /block_limit=n */
#define QUI$_JOB_SIZE_MINIMUM	48	/* queue: /block_limit=(n,"") */
#define QUI$_JOB_STATUS		49	/* job: status information */
#define QUI$_LAST_PAGE		50	/* file: /pages=n */
#define QUI$_LIBRARY_SPECIFICATION 51	/* queue: /library=file-specification */
#define QUI$_LOG_QUEUE		52	/* job: /printer=queue-name */
#define QUI$_LOG_SPECIFICATION	53	/* job: /log_file=file-specification */
#define QUI$_NOTE		54	/* job: /note=string */
#define QUI$_OPERATOR_REQUEST	55	/* job: /operator=string */
#define QUI$_OWNER_UIC		56	/* queue: /owner=uic */
#define QUI$_PAGE_SETUP_MODULES	57	/* form: /page_setup=(module,...) */
#define QUI$_PARAMETER_1	58	/* job: /parameter=string */
#define QUI$_PARAMETER_2	59
#define QUI$_PARAMETER_3	60
#define QUI$_PARAMETER_4	61
#define QUI$_PARAMETER_5	62
#define QUI$_PARAMETER_6	63
#define QUI$_PARAMETER_7	64
#define QUI$_PARAMETER_8	65
#define QUI$_PRIORITY		66	/* job: /priority=n */
#define QUI$_PROCESSOR		67	/* queue: /processor=filename */
#define QUI$_PROTECTION		68	/* queue: /protection=mask */
#define QUI$_QUEUE_FLAGS	69	/* queue: boolean information */
#define QUI$_QUEUE_NAME		70	/* job, queue: queue name */
#define QUI$_QUEUE_STATUS	71	/* queue: status information */
#define QUI$_REFUSAL_REASON	72	/* job: reason symbiont refused job */
#define QUI$_REQUEUE_PRIORITY	73	/* job: priority after requeue */
#define QUI$_REQUEUE_QUEUE_NAME	74	/* job: queue after requeue */
#define QUI$_SCSNODE_NAME	75	/* queue: /on=node:: */
#define QUI$_SEARCH_FLAGS	76	/* flags to control search */
#define QUI$_SEARCH_NAME	77	/* object name to search for */
#define QUI$_SEARCH_NUMBER	78	/* object number to search for */
#define QUI$_SUBMISSION_TIME	79	/* job: submission time */
#define QUI$_UIC		80	/* job: submitter's uic */
#define QUI$_USERNAME		81	/* job: submitter's username */
#define QUI$_WSDEFAULT		82	/* job, queue: /wsdefault=n */
#define QUI$_WSEXTENT		83	/* job, queue: /wsextent=n */
#define QUI$_WSQUOTA		84	/* job, queue: /wsquota=n */
#define QUI$_RESERVED_BOOLEAN_1	85	/* reserved for digital use (name may change) */
#define QUI$_RESERVED_BOOLEAN_2	86	/* reserved for digital use (name may change) */
#define QUI$_RESERVED_INPUT_1	87	/* reserved for digital use (name may change) */
#define QUI$_RESERVED_INPUT_2	88	/* reserved for digital use (name may change) */
#define QUI$_DEFAULT_FORM_NAME	89	/* default form name on queue */
#define QUI$_DEFAULT_FORM_NUMBER 90	/* default form number on queue */
#define QUI$_DEFAULT_FORM_STOCK	91	/* stock name for default form */
#define QUI$_JOB_PID		92	/* pid of batch job */
#define QUI$_RESERVED_OUTPUT_5	93	/* reserved for digital use (name may change) */
#define QUI$_RESERVED_OUTPUT_6	94	/* reserved for digital use (name may change) */
/*
 Structure of FILE_FLAGS item.
*/
#define QUI$M_FILE_BURST	0X1
#define QUI$M_FILE_BURST_EXP	0X2
#define QUI$M_FILE_DELETE	0X4
#define QUI$M_FILE_DOUBLE_SPACE	0X8
#define QUI$M_FILE_FLAG		0X10
#define QUI$M_FILE_FLAG_EXP	0X20
#define QUI$M_FILE_TRAILER	0X40
#define QUI$M_FILE_TRAILER_EXP	0X80
#define QUI$M_FILE_PAGE_HEADER	0X100
#define QUI$M_FILE_PAGINATE	0X200
#define QUI$M_FILE_PASSALL	0X400
#define QUI$M_FILE_PAGINATE_EXP	0X800
#define QUI$S_FILE_FLAGS	4
#define QUI$V_FILE_BURST	0	/* /burst */
#define QUI$V_FILE_BURST_EXP	1	/* /[no]burst explicit */
#define QUI$V_FILE_DELETE	2	/* /delete */
#define QUI$V_FILE_DOUBLE_SPACE	3	/* /space */
#define QUI$V_FILE_FLAG		4	/* /flag */
#define QUI$V_FILE_FLAG_EXP	5	/* /[no]flag explicit */
#define QUI$V_FILE_TRAILER	6	/* /trailer */
#define QUI$V_FILE_TRAILER_EXP	7	/* /[no]trailer explicit */
#define QUI$V_FILE_PAGE_HEADER	8	/* /header */
#define QUI$V_FILE_PAGINATE	9	/* /feed */
#define QUI$V_FILE_PASSALL	10	/* /passall */
#define QUI$V_FILE_PAGINATE_EXP	11	/* /[no]feed explicit */
/*
 Structure of FILE_STATUS item.
*/
#define QUI$M_FILE_CHECKPOINTED	0X1
#define QUI$M_FILE_EXECUTING	0X2
#define QUI$S_FILE_STATUS	4
#define QUI$V_FILE_CHECKPOINTED	0	/* file checkpointed */
#define QUI$V_FILE_EXECUTING	1	/* file currently executing */
/*
 Structure of FORM_FLAGS item.
*/
#define QUI$M_FORM_SHEET_FEED	0X1
#define QUI$M_FORM_TRUNCATE	0X2
#define QUI$M_FORM_WRAP		0X4
#define QUI$S_FORM_FLAGS	4
#define QUI$V_FORM_SHEET_FEED	0	/* /sheet_feed */
#define QUI$V_FORM_TRUNCATE	1	/* /truncate */
#define QUI$V_FORM_WRAP		2	/* /wrap */
/*
 Structure of JOB_FLAGS item.
*/
#define QUI$M_JOB_CPU_LIMIT		0X1
#define QUI$M_JOB_FILE_BURST		0X2
#define QUI$M_JOB_FILE_BURST_ONE	0X4
#define QUI$M_JOB_FILE_BURST_EXP	0X8
#define QUI$M_JOB_FILE_FLAG		0X10
#define QUI$M_JOB_FILE_FLAG_ONE		0X20
#define QUI$M_JOB_FILE_FLAG_EXP		0X40
#define QUI$M_JOB_FILE_TRAILER		0X80
#define QUI$M_JOB_FILE_TRAILER_ONE	0X100
#define QUI$M_JOB_FILE_TRAILER_EXP	0X200
#define QUI$M_JOB_LOG_DELETE		0X400
#define QUI$M_JOB_LOG_NULL		0X800
#define QUI$M_JOB_LOG_SPOOL		0X1000
#define QUI$M_JOB_LOWERCASE		0X2000
#define QUI$M_JOB_NOTIFY		0X4000
#define QUI$M_JOB_RESTART		0X8000
#define QUI$M_JOB_WSDEFAULT		0X10000
#define QUI$M_JOB_WSEXTENT		0X20000
#define QUI$M_JOB_WSQUOTA		0X40000
#define QUI$M_JOB_FILE_PAGINATE		0X80000
#define QUI$M_JOB_FILE_PAGINATE_EXP	0X100000
#define QUI$S_JOB_FLAGS		4
#define QUI$V_JOB_CPU_LIMIT	0	/* /cputime explicit */
#define QUI$V_JOB_FILE_BURST	1	/* /burst=all */
#define QUI$V_JOB_FILE_BURST_ONE 2	/* /burst=one */
#define QUI$V_JOB_FILE_BURST_EXP 3	/* /[no]burst explicit */
#define QUI$V_JOB_FILE_FLAG	4	/* /flag=all */
#define QUI$V_JOB_FILE_FLAG_ONE	5	/* /flag=one */
#define QUI$V_JOB_FILE_FLAG_EXP	6	/* /[no]flag explicit */
#define QUI$V_JOB_FILE_TRAILER	7	/* /trailer=all */
#define QUI$V_JOB_FILE_TRAILER_ONE 8	/* /trailer=one */
#define QUI$V_JOB_FILE_TRAILER_EXP 9	/* /[no]trailer explicit */
#define QUI$V_JOB_LOG_DELETE	10	/* /nokeep */
#define QUI$V_JOB_LOG_NULL	11	/* /nolog_file */
#define QUI$V_JOB_LOG_SPOOL	12	/* /printer */
#define QUI$V_JOB_LOWERCASE	13	/* /lowercase */
#define QUI$V_JOB_NOTIFY	14	/* /notify */
#define QUI$V_JOB_RESTART	15	/* /restart */
#define QUI$V_JOB_WSDEFAULT	16	/* /wsdefault explicit */
#define QUI$V_JOB_WSEXTENT	17	/* /wsextent explicit */
#define QUI$V_JOB_WSQUOTA	18	/* /wsquota explicit */
#define QUI$V_JOB_FILE_PAGINATE	19	/* /feed */
#define QUI$V_JOB_FILE_PAGINATE_EXP 20	/* /[no]feed explicit */
/*
 Structure of JOB_STATUS item.
*/
#define QUI$M_JOB_ABORTING	0X1
#define QUI$M_JOB_EXECUTING	0X2
#define QUI$M_JOB_HOLDING	0X4
#define QUI$M_JOB_INACCESSIBLE	0X8
#define QUI$M_JOB_REFUSED	0X10
#define QUI$M_JOB_REQUEUE	0X20
#define QUI$M_JOB_RESTARTING	0X40
#define QUI$M_JOB_RETAINED	0X80
#define QUI$M_JOB_STARTING	0X100
#define QUI$M_JOB_TIMED		0X200
#define QUI$S_JOB_STATUS	4
#define QUI$V_JOB_ABORTING	0	/* job is aborting */
#define QUI$V_JOB_EXECUTING	1	/* job is executing */
#define QUI$V_JOB_HOLDING	2	/* job is holding for /hold */
#define QUI$V_JOB_INACCESSIBLE	3	/* job is inaccessible */
#define QUI$V_JOB_REFUSED	4	/* job was refused by symbiont */
#define QUI$V_JOB_REQUEUE	5	/* job will requeue after abort */
#define QUI$V_JOB_RESTARTING	6	/* job started execution at least once */
#define QUI$V_JOB_RETAINED	7	/* job was retained by /retain */
#define QUI$V_JOB_STARTING	8	/* job is starting */
#define QUI$V_JOB_TIMED		9	/* job is holding for /after */
/*
 Structure of QUEUE_FLAGS item.
*/
#define QUI$M_QUEUE_BATCH		0X1
#define QUI$M_QUEUE_CPU_DEFAULT		0X2
#define QUI$M_QUEUE_CPU_LIMIT		0X4
#define QUI$M_QUEUE_FILE_BURST		0X8
#define QUI$M_QUEUE_FILE_BURST_ONE	0X10
#define QUI$M_QUEUE_FILE_FLAG		0X20
#define QUI$M_QUEUE_FILE_FLAG_ONE	0X40
#define QUI$M_QUEUE_FILE_TRAILER	0X80
#define QUI$M_QUEUE_FILE_TRAILER_ONE	0X100
#define QUI$M_QUEUE_GENERIC		0X200
#define QUI$M_QUEUE_GENERIC_SELECTION	0X400
#define QUI$M_QUEUE_JOB_BURST		0X800
#define QUI$M_QUEUE_JOB_FLAG		0X1000
#define QUI$M_QUEUE_JOB_SIZE_SCHED	0X2000
#define QUI$M_QUEUE_JOB_TRAILER		0X4000
#define QUI$M_QUEUE_RETAIN_ALL		0X8000
#define QUI$M_QUEUE_RETAIN_ERROR	0X10000
#define QUI$M_QUEUE_SWAP		0X20000
#define QUI$M_QUEUE_TERMINAL		0X40000
#define QUI$M_QUEUE_WSDEFAULT		0X80000
#define QUI$M_QUEUE_WSEXTENT		0X100000
#define QUI$M_QUEUE_WSQUOTA		0X200000
#define QUI$M_QUEUE_FILE_PAGINATE	0X400000
#define QUI$M_QUEUE_RECORD_BLOCKING	0X800000
#define QUI$S_QUEUE_FLAGS	4
#define QUI$V_QUEUE_BATCH	0	/* /batch */
#define QUI$V_QUEUE_CPU_DEFAULT	1	/* /cpudefault specified */
#define QUI$V_QUEUE_CPU_LIMIT	2	/* /cpumaximum specified */
#define QUI$V_QUEUE_FILE_BURST	3	/* /default=burst=all */
#define QUI$V_QUEUE_FILE_BURST_ONE 4	/* /default=burst=one */
#define QUI$V_QUEUE_FILE_FLAG	5	/* /default=flag=all */
#define QUI$V_QUEUE_FILE_FLAG_ONE 6	/* /default=flag=one */
#define QUI$V_QUEUE_FILE_TRAILER 7	/* /default=trailer=all */
#define QUI$V_QUEUE_FILE_TRAILER_ONE 8	/* /default=trailer=one */
#define QUI$V_QUEUE_GENERIC	9	/* /generic */
#define QUI$V_QUEUE_GENERIC_SELECTION 10	/* /enable_generic */
#define QUI$V_QUEUE_JOB_BURST	11	/* /separate=burst */
#define QUI$V_QUEUE_JOB_FLAG	12	/* /separate=flag */
#define QUI$V_QUEUE_JOB_SIZE_SCHED 13	/* /schedule=size */
#define QUI$V_QUEUE_JOB_TRAILER	14	/* /separate=trailer */
#define QUI$V_QUEUE_RETAIN_ALL	15	/* /retain=all */
#define QUI$V_QUEUE_RETAIN_ERROR 16	/* /retain=error */
#define QUI$V_QUEUE_SWAP	17	/* /nodisable_swapping */
#define QUI$V_QUEUE_TERMINAL	18	/* /terminal or terminal device */
#define QUI$V_QUEUE_WSDEFAULT	19	/* /wsdefault specified */
#define QUI$V_QUEUE_WSEXTENT	20	/* /wsextent specified */
#define QUI$V_QUEUE_WSQUOTA	21	/* /wsquota specified */
#define QUI$V_QUEUE_FILE_PAGINATE 22	/* /default=feed */
#define QUI$V_QUEUE_RECORD_BLOCKING 23	/* /record_blocking */
/*
 Structure of QUEUE_STATUS item.
*/
#define QUI$M_QUEUE_ALIGNING		0X1
#define QUI$M_QUEUE_IDLE		0X2
#define QUI$M_QUEUE_LOWERCASE		0X4
#define QUI$M_QUEUE_OPERATOR_REQUEST	0X8
#define QUI$M_QUEUE_PAUSED		0X10
#define QUI$M_QUEUE_PAUSING		0X20
#define QUI$M_QUEUE_REMOTE		0X40
#define QUI$M_QUEUE_RESETTING		0X80
#define QUI$M_QUEUE_RESUMING		0X100
#define QUI$M_QUEUE_SERVER		0X200
#define QUI$M_QUEUE_STALLED		0X400
#define QUI$M_QUEUE_STARTING		0X800
#define QUI$M_QUEUE_STOPPED		0X1000
#define QUI$M_QUEUE_STOPPING		0X2000
#define QUI$M_QUEUE_UNAVAILABLE		0X4000
#define QUI$S_QUEUE_STATUS	4
#define QUI$V_QUEUE_ALIGNING	0	/* queue is aligning */
#define QUI$V_QUEUE_IDLE	1	/* queue is idle */
#define QUI$V_QUEUE_LOWERCASE	2	/* lowercase device */
#define QUI$V_QUEUE_OPERATOR_REQUEST 3	/* queue is doing /operator */
#define QUI$V_QUEUE_PAUSED	4	/* queue is paused */
#define QUI$V_QUEUE_PAUSING	5	/* queue is pausing */
#define QUI$V_QUEUE_REMOTE	6	/* remote device */
#define QUI$V_QUEUE_RESETTING	7	/* incomplete remote request to reset */
#define QUI$V_QUEUE_RESUMING	8	/* queue is resuming */
#define QUI$V_QUEUE_SERVER	9	/* server symbiont */
#define QUI$V_QUEUE_STALLED	10	/* device is stalled */
#define QUI$V_QUEUE_STARTING	11	/* queue is starting */
#define QUI$V_QUEUE_STOPPED	12	/* queue is stopped */
#define QUI$V_QUEUE_STOPPING	13	/* queue is stopping */
#define QUI$V_QUEUE_UNAVAILABLE	14	/* device is unavailable */
/*
 Definition of SEARCH_FLAGS
*/
#define QUI$M_SEARCH_ALL_JOBS	0X1
#define QUI$M_SEARCH_WILDCARD	0X2
#define QUI$M_SEARCH_BATCH	0X4
#define QUI$M_SEARCH_SYMBIONT	0X8
#define QUI$M_SEARCH_THIS_JOB	0X10
#define QUI$S_SEARCH_FLAGS	4
#define QUI$V_SEARCH_ALL_JOBS	0	/* select all jobs (else only those with same username as caller) */
#define QUI$V_SEARCH_WILDCARD	1	/* force a wildcard operation */
#define QUI$V_SEARCH_BATCH	2	/* select batch queues */
#define QUI$V_SEARCH_SYMBIONT	3	/* select symbiont (output) queues */
#define QUI$V_SEARCH_THIS_JOB	4	/* select only caller's batch job (forcing new context) */
 
