/*+ SMBDEF
 Symbolic definitions for the symbiont to job controller interface.
 Extracted from V4.4 SYS$LIBRARY:LIB.REQ on  10-Jun-1986 
 Structure level
*/
#define SMBMSG$K_STRUCTURE_LEVEL   1	/* current structure level */
#define SMBMSG$K_STRUCTURE_LEVEL_1 1	/* structure level 1 */
/*
 Define request codes
*/
#define SMBMSG$K_PAUSE_TASK	1	/* - stop /queue */
#define SMBMSG$K_RESET_STREAM	2	/* - stop /queue /reset */
#define SMBMSG$K_RESUME_TASK	3	/* - start /queue (when paused) */
#define SMBMSG$K_START_STREAM	4	/* - start /queue (when stopped) */
#define SMBMSG$K_START_TASK	5	/* - task available */
#define SMBMSG$K_STOP_STREAM	6	/* - stop /queue /next */
#define SMBMSG$K_STOP_TASK	7	/* - stop /queue /abort or /requeue */
#define SMBMSG$K_TASK_COMPLETE	8	/* - stream is idle */
#define SMBMSG$K_TASK_STATUS	9	/* - asynchronous status update */
#define SMBMSG$K_MAX_REQUEST_CODE	10	/* must be last */
#define SMBMSG$S_REQUEST_HEADER	4
/*
 Item header
*/
#define SMBMSG$K_ACCOUNTING_DATA 1	/* - accounting information */
#define SMBMSG$K_ACCOUNT_NAME	2	/* - account name */
#define SMBMSG$K_AFTER_TIME	3	/* - /after value */
#define SMBMSG$K_ALIGNMENT_PAGES 4	/* - /align count */
#define SMBMSG$K_BOTTOM_MARGIN	5	/* - trailing blank lines */
#define SMBMSG$K_CHARACTERISTICS 6	/* - /characteristics value */
#define SMBMSG$K_CHECKPOINT_DATA 7	/* - checkpoint information */
#define SMBMSG$K_CONDITION_VECTOR 8	/* - task error messages */
#define SMBMSG$K_DEVICE_NAME	9	/* - /on value */
#define SMBMSG$K_DEVICE_STATUS	10	/* - device status */
#define SMBMSG$K_ENTRY_NUMBER	11	/* - job entry number */
#define SMBMSG$K_EXECUTOR_QUEUE	12	/* - this output queue */
#define SMBMSG$K_FILE_COPIES	13	/* - /copies value */
#define SMBMSG$K_FILE_COUNT	14	/* - current file copy number */
#define SMBMSG$K_FILE_SETUP_MODULES 15	/* - file setup module list */
#define SMBMSG$K_FIRST_PAGE	16	/* - first page to print */
#define SMBMSG$K_FORM_LENGTH	17	/* - lines per page */
#define SMBMSG$K_FORM_NAME	18	/* - name of physical form */
#define SMBMSG$K_FORM_SETUP_MODULES 19	/* - form setup module list */
#define SMBMSG$K_FORM_WIDTH	20	/* - columns per line */
#define SMBMSG$K_FILE_IDENTIFICATION 21	/* - device, fid, and did */
#define SMBMSG$K_FILE_SPECIFICATION 22	/* - file name */
#define SMBMSG$K_JOB_COPIES	23	/* - /job_count value */
#define SMBMSG$K_JOB_COUNT	24	/* - current job copy number */
#define SMBMSG$K_JOB_NAME	25	/* - /name value */
#define SMBMSG$K_JOB_RESET_MODULES 26	/* - job reset module list */
#define SMBMSG$K_LAST_PAGE	27	/* - last page to print */
#define SMBMSG$K_LEFT_MARGIN	28	/* - leading blank columns */
#define SMBMSG$K_LIBRARY_SPECIFICATION 29 /* - library name */
#define SMBMSG$K_MAXIMUM_STREAMS 30	/* - maximum supported symbiont */
#define SMBMSG$K_MESSAGE_VECTOR	31	/* - error messages to print */
#define SMBMSG$K_NOTE		32	/* - /note value */
#define SMBMSG$K_PAGE_SETUP_MODULES 33	/* - page setup module list */
#define SMBMSG$K_PARAMETER_1	34	/* - user parameter 1 */
#define SMBMSG$K_PARAMETER_2	35	/* - user parameter 2 */
#define SMBMSG$K_PARAMETER_3	36	/* - user parameter 3 */
#define SMBMSG$K_PARAMETER_4	37	/* - user parameter 4 */
#define SMBMSG$K_PARAMETER_5	38	/* - user parameter 5 */
#define SMBMSG$K_PARAMETER_6	39	/* - user parameter 6 */
#define SMBMSG$K_PARAMETER_7	40	/* - user parameter 7 */
#define SMBMSG$K_PARAMETER_8	41	/* - user parameter 8 */
#define SMBMSG$K_PRINT_CONTROL	42	/* - printing control */
#define SMBMSG$K_PRIORITY	43	/* - queue priority */
#define SMBMSG$K_QUEUE		44	/* - generic queue name */
#define SMBMSG$K_REFUSE_REASON	45	/* - reason task refused */
#define SMBMSG$K_RELATIVE_PAGE	46	/* - /backward, /forward values */
#define SMBMSG$K_REQUEST_CONTROL 47	/* - request control */
#define SMBMSG$K_REQUEST_RESPONSE 48	/* - request code being responded to */
#define SMBMSG$K_RIGHT_MARGIN	49	/* - trailing blank columns */
#define SMBMSG$K_SEARCH_STRING	50	/* - /search value */
#define SMBMSG$K_SEPARATION_CONTROL 51	/* - separation control */
#define SMBMSG$K_STOP_CONDITION	52	/* - reason for print abort */
#define SMBMSG$K_TIME_QUEUED	53	/* - time queued */
#define SMBMSG$K_TOP_MARGIN	54	/* - leading blank lines */
#define SMBMSG$K_UIC		55	/* - uic of submittor */
#define SMBMSG$K_USER_NAME	56	/* - username */

#define SMBMSG$K_MAX_ITEM_CODE	57	/* must be last */
#define SMBMSG$S_ITEM_HEADER	4
/*
 Define item codes return data structures
*/
struct SMBMSG_DATA {
/*
 ACCOUNTING_DATA item
*/
#define SMBMSG$S_ACCOUNTING_DATA	16
    variant_struct {
	unsigned long smbmsg$l_pages_printed;	/* pages printed */
	unsigned long smbmsg$l_qio_puts;	/* lines printed */
	unsigned long smbmsg$l_rms_gets;	/* file reads */
	unsigned long smbmsg$l_cpu_time;	/* processor time */
	} smbmsg$r_accounting_data;
/*
 CHECKPOINT_DATA item
*/
#define SMBMSG$S_CHECKPOINT_DATA	24
	variant_struct {
	unsigned char smbmsg$b_filler;		/* reserved */
	unsigned char smbmsg$b_checkpoint_level; /* checkpoint structure level */
	unsigned short smbmsg$w_offset;		/* offset into record */
	unsigned long smbmsg$l_carcon;		/* carriage control */
	unsigned long smbmsg$l_page;		/* page number */
	unsigned long smbmsg$l_record_number;	/* record number */
	unsigned long smbmsg$q_user_key[2];	/* user positioning key */
	} smbmsg$r_checkpoint_data;
#define SMBMSG$S_USER_KEY	8

/*
 DEVICE_STATUS item
*/
#define SMBMSG$M_LOWERCASE	0X1
#define SMBMSG$M_PAUSE_TASK	0X2
#define SMBMSG$M_REMOTE		0X4
#define SMBMSG$M_SERVER		0X8
#define SMBMSG$M_STALLED	0X10
#define SMBMSG$M_STOP_STREAM	0X20
#define SMBMSG$M_TERMINAL	0X40
#define SMBMSG$M_UNAVAILABLE	0X80

#define SMBMSG$S_DEVICE_STATUS	4
    variant_struct {
	unsigned smbmsg$v_lowercase : 1;	/* - supports lowercase */
	unsigned smbmsg$v_pause_task : 1;	/* - symbiont initiated pause */
	unsigned smbmsg$v_remote : 1;		/* - device is remote */
	unsigned smbmsg$v_server : 1;		/* - server symbiont */
	unsigned smbmsg$v_stalled : 1;		/* - task stalled */
	unsigned smbmsg$v_stop_stream : 1;	/* - symbiont requesting stop stream */
	unsigned smbmsg$v_terminal : 1;		/* - device is a terminal */
	unsigned smbmsg$v_unavailable : 1;	/* - device unavailable */
	} smbmsg$r_device_flags;
/*
 PRINT_CONTROL item
*/ 
#define SMBMSG$M_DOUBLE_SPACE	0X1
#define SMBMSG$M_PAGE_HEADER	0X2
#define SMBMSG$M_PAGINATE	0X4
#define SMBMSG$M_PASSALL	0X8
#define SMBMSG$M_SEQUENCED	0X10
#define SMBMSG$M_SHEET_FEED	0X20
#define SMBMSG$M_TRUNCATE	0X40
#define SMBMSG$M_WRAP		0X80
#define SMBMSG$M_RECORD_BLOCKING 0X100

#define SMBMSG$S_PRINT_CONTROL	4
    variant_struct {
	unsigned smbmsg$v_double_space : 1;	/* - double space */
	unsigned smbmsg$v_page_header : 1;	/* - print page headers */
	unsigned smbmsg$v_paginate : 1;		/* - insert <ff>'s */
	unsigned smbmsg$v_passall : 1;		/* - binary print file */
	unsigned smbmsg$v_sequenced : 1;	/* - print sequence numbers */
	unsigned smbmsg$v_sheet_feed : 1;	/* - pause at every tof */
	unsigned smbmsg$v_truncate : 1;		/* - truncate on overflow */
	unsigned smbmsg$v_wrap : 1;		/* - wrap on overflow */
	unsigned smbmsg$v_record_blocking : 1;	/* - block records in output buffer */
	} smbmsg$r_print_flags;
/*
 REQUEST_CONTROL item
*/
#define SMBMSG$M_ALIGNMENT_MASK	0X1
#define SMBMSG$M_PAUSE_COMPLETE	0X2
#define SMBMSG$M_RESTARTING	0X4
#define SMBMSG$M_TOP_OF_FILE	0X8

#define SMBMSG$S_REQUEST	4
    variant_struct {
	unsigned smbmsg$v_alignment_mask : 1;	/* - print a's and 9's */
	unsigned smbmsg$v_pause_complete : 1;	/* - pause when request complete */
	unsigned smbmsg$v_restarting : 1;	/* - job is restarting */
	unsigned smbmsg$v_top_of_file : 1;	/* - rewind before resume */
	} smbmsg$r_request_flags;
/*
 SEPARATION_CONTROL item
*/
#define SMBMSG$M_FILE_BURST		0X1
#define SMBMSG$M_FILE_FLAG		0X2
#define SMBMSG$M_FILE_TRAILER		0X4
#define SMBMSG$M_FILE_TRAILER_ABORT	0X8
#define SMBMSG$M_JOB_FLAG		0X10
#define SMBMSG$M_JOB_BURST		0X20
#define SMBMSG$M_JOB_RESET		0X40
#define SMBMSG$M_JOB_RESET_ABORT	0X80
#define SMBMSG$M_JOB_TRAILER		0X100
#define SMBMSG$M_JOB_TRAILER_ABORT	0X200
#define SMBMSG$M_FIRST_FILE_OF_JOB	0X400
#define SMBMSG$M_LAST_FILE_OF_JOB	0X800

#define SMBMSG$S_SEPARATION_CONTROL	4
    variant_struct {
	unsigned smbmsg$v_file_burst : 1;	/* - print file burst page */
	unsigned smbmsg$v_file_flag : 1;	/* - print file flag page */
	unsigned smbmsg$v_file_trailer : 1;	/* - print file trailer page */
	unsigned smbmsg$v_file_trailer_abort : 1; /* - print file trailer page */
	unsigned smbmsg$v_job_flag : 1;		/* - print job flag page */
	unsigned smbmsg$v_job_burst : 1;	/* - print job burst page */
	unsigned smbmsg$v_job_reset : 1;	/* - execute job reset sequence */
	unsigned smbmsg$v_job_reset_abort : 1;	/* - execute job reset sequence */
	unsigned smbmsg$v_job_trailer : 1;	/* - print job trailer page */
	unsigned smbmsg$v_job_trailer_abort : 1; /* - print job trailer page */
	unsigned smbmsg$v_first_file_of_job : 1; /* - this is the first file of the current job */
	unsigned smbmsg$v_last_file_of_job : 1;	/* - this is the last file of the current job */
	} smbmsg$r_separation_flags;
    };
